/**
 */
package linkedlist.tests;

import junit.framework.TestCase;

import junit.textui.TestRunner;

import linkedlist.LinkedlistFactory;
import linkedlist.List;
import linkedlist.Node;
import linkedlist.impl.LinkedlistFactoryImpl;

/**
 * <!-- begin-user-doc -->
 * A test case for the model object '<em><b>List</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following operations are tested:
 * <ul>
 *   <li>{@link linkedlist.List#find(java.lang.String) <em>Find</em>}</li>
 *   <li>{@link linkedlist.List#toString() <em>To String</em>}</li>
 * </ul>
 * </p>
 * @generated
 */
public class ListTest extends TestCase {

	/**
	 * The fixture for this List test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected List fixture = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static void main(String[] args) {
		TestRunner.run(ListTest.class);
	}

	/**
	 * Constructs a new List test case with the given name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ListTest(String name) {
		super(name);
	}

	/**
	 * Sets the fixture for this List test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void setFixture(List fixture) {
		this.fixture = fixture;
	}

	/**
	 * Returns the fixture for this List test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected List getFixture() {
		return fixture;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#setUp()
	 * @generated
	 */
	@Override
	protected void setUp() throws Exception {
		setFixture(LinkedlistFactory.eINSTANCE.createList());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#tearDown()
	 * @generated
	 */
	@Override
	protected void tearDown() throws Exception {
		setFixture(null);
	}

	
	/**
	 * Tests the '{@link linkedlist.List#find(java.lang.String) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#find(java.lang.String)
	 * @generated
	 */
	public void testFind__String() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link linkedlist.List#toString() <em>To String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#toString()
	 * @generated
	 */
	public void testToString() {
		// TODO: implement this operation test method
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}


	public List list1; 
	
	// initialize a list for testing
	public void initList1 () {
		Node[] nodes;
		// initialize factory
		LinkedlistFactoryImpl.init();
	    // retrieve the default factory singleton
	    LinkedlistFactory factory = LinkedlistFactory.eINSTANCE;
	    // create an instance of List
	    nodes = new Node[10];
	    for (int i=0; i<10; i++) {
	    	nodes[i] = factory.createNode();
	    	nodes[i].setName("n"+i);
	    	if (i>0) 
	    		nodes[i].setPrev(nodes[i-1]);
	    }
	    list1 = factory.createList();
	    list1.setHead(nodes[0]);
	}

	/**
	 * Tests the '{@link linkedlist.List#toString() <em>To String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#toString()
	 */
	public void test1_toString() {
		if (list1==null) initList1();
	    // System.out.println(list1.toString());
		String str = "n0 -> n1 -> n2 -> n3 -> n4 -> n5 -> n6 -> n7 -> n8 -> n9";
	    assertTrue(str.equals(list1.toString()));
	}
	
	/**
	 * Tests the '{@link linkedlist.List#find(java.lang.String) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#find(java.lang.String)
	 */
	public void  test1_find() {
		if (list1==null) initList1();
		assertTrue(list1.find("n5"));
	}
	
	/**
	 * Tests the '{@link linkedlist.List#find(java.lang.String) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#find(java.lang.String)
	 */
	public void  test2_find() {
		if (list1==null) initList1();
		assertFalse(list1.find("n10"));
	}
	
	/**
	 * Tests the '{@link linkedlist.List#find(java.lang.String) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see linkedlist.List#find(java.lang.String)
	 */
	public void test3_find() {
		if (list1==null) initList1();
	    assertTrue(list1.find("n3"));
	    assertFalse(list1.find("n10"));
	}
} //ListTest
